# coding: utf-8

"""
    VMware Aria Automation Assembler IaaS API

    IAAS API is a RESTful service, which allows users to execute provisioning related UI actions via an API.  This page describes the RESTful APIs for IAAS API. The APIs facilitate CRUD operations on the various resources and entities used throughout VMware Aria Automation Assembler(Cloud Accounts, Cloud zones, Computes, Mappings, etc.) and allows operations on them (creating a cloud account, patching a machine, creating image progile, etc.).  The APIs that list collections of resources also support OData like implementation. Below query params can be used across different IAAS API endpoints  Example: 1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.     ```/iaas/api/cloud-accounts?$orderby=name%20desc```  2. `$top` -  number of records you want to get.     ```/iaas/api/cloud-accounts?$top=20```  3. `$skip` -  number of records you want to skip.      ```/iaas/api/cloud-accounts?$skip=10```  4. `$select` - select a subset of properties to include in the response.        ```/project-service/api/projects?$top=10&$skip=2```  5. `$filter` -  filter the results by a specified predicate expression. Operators: eq, ne, and, or.\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'ABC*'``` - name starts with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC*'``` - name contains 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC'``` - name ends with 'ABC'\\     /iaas/api/projects and /iaas/api/deployments support different format for partial match:\\     ```/iaas/api/projects?$filter=startswith(name, 'ABC')``` - name starts with 'ABC'\\     ```/iaas/api/projects?$filter=substringof('ABC', name``` - name contains 'ABC'\\     ```/iaas/api/projects?$filter=endswith(name, 'ABC')``` - name ends with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20ne%20'example-cloud-account'%20or%20customProperties.isExternal%20eq%20'false'```  6. `$count` -  flag which when specified, regardless of the assigned value, shows the total number of records. If the collection has a filter it shows the number of records matching the filter.\\     ```/iaas/api/cloud-accounts?$count=true```   # noqa: E501

    OpenAPI spec version: 2021-07-15
    Contact: sales@vmware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from idem_vra.client.vra_iaas_lib.api_client import ApiClient


class PackageImportApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_package_metadata(self, id, tus_resumable, **kwargs):  # noqa: E501
        """Get package metadata.  # noqa: E501

        This API implements the TUS RFC: https://github.com/tus/tus-resumable-upload-protocol/blob/main/protocol.md  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_package_metadata(id, tus_resumable, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str id: IPAM package id (required)
        :param str tus_resumable: Tus version (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information refer to /iaas/api/about
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_package_metadata_with_http_info(id, tus_resumable, **kwargs)  # noqa: E501
        else:
            (data) = self.get_package_metadata_with_http_info(id, tus_resumable, **kwargs)  # noqa: E501
            return data

    def get_package_metadata_with_http_info(self, id, tus_resumable, **kwargs):  # noqa: E501
        """Get package metadata.  # noqa: E501

        This API implements the TUS RFC: https://github.com/tus/tus-resumable-upload-protocol/blob/main/protocol.md  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_package_metadata_with_http_info(id, tus_resumable, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str id: IPAM package id (required)
        :param str tus_resumable: Tus version (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information refer to /iaas/api/about
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'tus_resumable', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_package_metadata" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `get_package_metadata`")  # noqa: E501
        # verify the required parameter 'tus_resumable' is set
        if ('tus_resumable' not in params or
                params['tus_resumable'] is None):
            raise ValueError("Missing the required parameter `tus_resumable` when calling `get_package_metadata`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501

        query_params = []
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}
        if 'tus_resumable' in params:
            header_params['Tus-Resumable'] = params['tus_resumable']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/iaas/api/integrations-ipam/package-import/{id}', 'HEAD',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_tus_option(self, **kwargs):  # noqa: E501
        """Get Tus options  # noqa: E501

        Tus options as headers: Tus-Extension, Tus-Max-Size, Tus-Version.  This API implements the TUS RFC: https://github.com/tus/tus-resumable-upload-protocol/blob/main/protocol.md  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_tus_option(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information refer to /iaas/api/about
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_tus_option_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_tus_option_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_tus_option_with_http_info(self, **kwargs):  # noqa: E501
        """Get Tus options  # noqa: E501

        Tus options as headers: Tus-Extension, Tus-Max-Size, Tus-Version.  This API implements the TUS RFC: https://github.com/tus/tus-resumable-upload-protocol/blob/main/protocol.md  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_tus_option_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information refer to /iaas/api/about
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_tus_option" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/iaas/api/integrations-ipam/package-import', 'OPTIONS',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def import_package(self, tus_resumable, upload_offset, content_type, id, **kwargs):  # noqa: E501
        """Import package  # noqa: E501

        Import IPAM package on chunks of specified size.   This API implements the TUS RFC: https://github.com/tus/tus-resumable-upload-protocol/blob/main/protocol.md  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.import_package(tus_resumable, upload_offset, content_type, id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str tus_resumable: Tus version (required)
        :param str upload_offset: Upload offset (required)
        :param str content_type: Content type (required)
        :param str id: IPAM package id (required)
        :param Object body:
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information refer to /iaas/api/about
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.import_package_with_http_info(tus_resumable, upload_offset, content_type, id, **kwargs)  # noqa: E501
        else:
            (data) = self.import_package_with_http_info(tus_resumable, upload_offset, content_type, id, **kwargs)  # noqa: E501
            return data

    def import_package_with_http_info(self, tus_resumable, upload_offset, content_type, id, **kwargs):  # noqa: E501
        """Import package  # noqa: E501

        Import IPAM package on chunks of specified size.   This API implements the TUS RFC: https://github.com/tus/tus-resumable-upload-protocol/blob/main/protocol.md  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.import_package_with_http_info(tus_resumable, upload_offset, content_type, id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str tus_resumable: Tus version (required)
        :param str upload_offset: Upload offset (required)
        :param str content_type: Content type (required)
        :param str id: IPAM package id (required)
        :param Object body:
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information refer to /iaas/api/about
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['tus_resumable', 'upload_offset', 'content_type', 'id', 'body', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method import_package" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'tus_resumable' is set
        if ('tus_resumable' not in params or
                params['tus_resumable'] is None):
            raise ValueError("Missing the required parameter `tus_resumable` when calling `import_package`")  # noqa: E501
        # verify the required parameter 'upload_offset' is set
        if ('upload_offset' not in params or
                params['upload_offset'] is None):
            raise ValueError("Missing the required parameter `upload_offset` when calling `import_package`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `import_package`")  # noqa: E501
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `import_package`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501

        query_params = []
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}
        if 'tus_resumable' in params:
            header_params['Tus-Resumable'] = params['tus_resumable']  # noqa: E501
        if 'upload_offset' in params:
            header_params['Upload-Offset'] = params['upload_offset']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/iaas/api/integrations-ipam/package-import/{id}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def import_package_http_method_override(self, tus_resumable, upload_offset, content_type, x_http_method_override, id, **kwargs):  # noqa: E501
        """Import package  # noqa: E501

        Import IPAM package on chunks of specified size with additional http method override.   This API implements the TUS RFC: https://github.com/tus/tus-resumable-upload-protocol/blob/main/protocol.md#x-http-method-override  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.import_package_http_method_override(tus_resumable, upload_offset, content_type, x_http_method_override, id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str tus_resumable: Tus version (required)
        :param str upload_offset: Upload offset (required)
        :param str content_type: Content type (required)
        :param str x_http_method_override: The http method to be used on the server instead of the actual method of the request. This header usage is part of the specfication for resumable uploads - https://tus.io/protocols/resumable-upload (required)
        :param str id: IPAM package id (required)
        :param Object body:
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information refer to /iaas/api/about
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.import_package_http_method_override_with_http_info(tus_resumable, upload_offset, content_type, x_http_method_override, id, **kwargs)  # noqa: E501
        else:
            (data) = self.import_package_http_method_override_with_http_info(tus_resumable, upload_offset, content_type, x_http_method_override, id, **kwargs)  # noqa: E501
            return data

    def import_package_http_method_override_with_http_info(self, tus_resumable, upload_offset, content_type, x_http_method_override, id, **kwargs):  # noqa: E501
        """Import package  # noqa: E501

        Import IPAM package on chunks of specified size with additional http method override.   This API implements the TUS RFC: https://github.com/tus/tus-resumable-upload-protocol/blob/main/protocol.md#x-http-method-override  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.import_package_http_method_override_with_http_info(tus_resumable, upload_offset, content_type, x_http_method_override, id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str tus_resumable: Tus version (required)
        :param str upload_offset: Upload offset (required)
        :param str content_type: Content type (required)
        :param str x_http_method_override: The http method to be used on the server instead of the actual method of the request. This header usage is part of the specfication for resumable uploads - https://tus.io/protocols/resumable-upload (required)
        :param str id: IPAM package id (required)
        :param Object body:
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information refer to /iaas/api/about
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['tus_resumable', 'upload_offset', 'content_type', 'x_http_method_override', 'id', 'body', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method import_package_http_method_override" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'tus_resumable' is set
        if ('tus_resumable' not in params or
                params['tus_resumable'] is None):
            raise ValueError("Missing the required parameter `tus_resumable` when calling `import_package_http_method_override`")  # noqa: E501
        # verify the required parameter 'upload_offset' is set
        if ('upload_offset' not in params or
                params['upload_offset'] is None):
            raise ValueError("Missing the required parameter `upload_offset` when calling `import_package_http_method_override`")  # noqa: E501
        # verify the required parameter 'content_type' is set
        if ('content_type' not in params or
                params['content_type'] is None):
            raise ValueError("Missing the required parameter `content_type` when calling `import_package_http_method_override`")  # noqa: E501
        # verify the required parameter 'x_http_method_override' is set
        if ('x_http_method_override' not in params or
                params['x_http_method_override'] is None):
            raise ValueError("Missing the required parameter `x_http_method_override` when calling `import_package_http_method_override`")  # noqa: E501
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `import_package_http_method_override`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501

        query_params = []
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}
        if 'tus_resumable' in params:
            header_params['Tus-Resumable'] = params['tus_resumable']  # noqa: E501
        if 'upload_offset' in params:
            header_params['Upload-Offset'] = params['upload_offset']  # noqa: E501
        if 'content_type' in params:
            header_params['Content-Type'] = params['content_type']  # noqa: E501
        if 'x_http_method_override' in params:
            header_params['X-HTTP-Method-Override'] = params['x_http_method_override']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/iaas/api/integrations-ipam/package-import/{id}', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def reserve_package(self, tus_resumable, upload_length, **kwargs):  # noqa: E501
        """Reserve package  # noqa: E501

        This operation has two purposes:  1. Make initial request for importing package. Location of the new package is returned as a response header if body is not provided.   2. Finalize the import when all batches are sent to the server if bundleIdis provided or make the complete import if compressedBundle is provided   This API implements the TUS RFC: https://github.com/tus/tus-resumable-upload-protocol/blob/main/protocol.md  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.reserve_package(tus_resumable, upload_length, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str tus_resumable: Tus version (required)
        :param str upload_length: Length of file in bytes (required)
        :param IntegrationsipamPackageimportBody body: Package import request specification
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information refer to /iaas/api/about
        :return: InlineResponse2018
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.reserve_package_with_http_info(tus_resumable, upload_length, **kwargs)  # noqa: E501
        else:
            (data) = self.reserve_package_with_http_info(tus_resumable, upload_length, **kwargs)  # noqa: E501
            return data

    def reserve_package_with_http_info(self, tus_resumable, upload_length, **kwargs):  # noqa: E501
        """Reserve package  # noqa: E501

        This operation has two purposes:  1. Make initial request for importing package. Location of the new package is returned as a response header if body is not provided.   2. Finalize the import when all batches are sent to the server if bundleIdis provided or make the complete import if compressedBundle is provided   This API implements the TUS RFC: https://github.com/tus/tus-resumable-upload-protocol/blob/main/protocol.md  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.reserve_package_with_http_info(tus_resumable, upload_length, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str tus_resumable: Tus version (required)
        :param str upload_length: Length of file in bytes (required)
        :param IntegrationsipamPackageimportBody body: Package import request specification
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information refer to /iaas/api/about
        :return: InlineResponse2018
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['tus_resumable', 'upload_length', 'body', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method reserve_package" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'tus_resumable' is set
        if ('tus_resumable' not in params or
                params['tus_resumable'] is None):
            raise ValueError("Missing the required parameter `tus_resumable` when calling `reserve_package`")  # noqa: E501
        # verify the required parameter 'upload_length' is set
        if ('upload_length' not in params or
                params['upload_length'] is None):
            raise ValueError("Missing the required parameter `upload_length` when calling `reserve_package`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}
        if 'tus_resumable' in params:
            header_params['Tus-Resumable'] = params['tus_resumable']  # noqa: E501
        if 'upload_length' in params:
            header_params['Upload-Length'] = params['upload_length']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Authorization']  # noqa: E501

        return self.api_client.call_api(
            '/iaas/api/integrations-ipam/package-import', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2018',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
